function [GK] = globalK(node,elem,k,ndim)
% calculate the global stiffness matrix
% input: node,elem,k,ndim
% output: GK

% calculate the geometric quantity for each element
aux = auxgeometry(node,elem);% 计算每个单元的形心，面积，半径，具体什么原理不用管
centroid = aux.centroid;  
diameter = aux.diameter;  
area = aux.area;


sumElem = size(elem,1); % the number of element
sumNode = size(node,1);


elemLen = cellfun('length',elem);
nnz = sum(elemLen.^2);
NsumNode = sumNode;


ii = zeros(nnz,1); jj = zeros(nnz,1); ss = zeros(nnz,1); 

% calculate element stiffness matrix

ia = 0;
for n = 1:sumElem
    AK = elemK(n,centroid,diameter,area,node,elem,ndim,k);
    AB = reshape(AK',1,[]); 
    index = elem{n};
    Nv = length(index);
    % --------- assembly index for ellptic projection -----------
    indexDof = index;  Ndof = Nv;  % local to global index
    ii(ia+1:ia+Ndof^2) = reshape(repmat(indexDof, Ndof, 1), [], 1);
    jj(ia+1:ia+Ndof^2) = repmat(indexDof(:), Ndof, 1);
    ss(ia+1:ia+Ndof^2) = AB(:);
    ia = ia + Ndof^2;
end

GK = sparse(ii,jj,ss,NsumNode,NsumNode);