function Int = integralTri(n,nodeT,elemT,k,hK,c,ndim)
%integralTri approximates integrals in a polygonal domain with trianguation (nodeT,elemT).
% n: n-th order quadrature rule
% 这个函数，仅针对计算m

[lambda,weight] = quadpts(n);
NT = size(elemT,1); 
if  k == 2
    Int = zeros(1,6);
elseif k == 3
    Int = zeros(3,10);
end


for iel = 1:NT
    vT = nodeT(elemT(iel,:),:);
    area = 0.5*abs(det([[1;1;1],vT]));
    
    xy = lambda*vT;
    for p = 1:size(xy,1)
        if k == 2
            f = myM([xy(p,1),xy(p,2)],k,hK,c,ndim);
        elseif k == 3
            f = [1;(xy(p,1)-c(1))/hK;(xy(p,2)-c(2))/hK]*myM([xy(p,1),xy(p,2)],k,hK,c,ndim);
        end
        Int = Int + area*weight(p)*f;
    end
end