clear;
load('meshdata32.mat');

% drew the mesh

% showmesh(node,elem);
% findnode(node);
% findelem(node,elem);

k = 1; % 阶数，可选1-3
ndim = 2;

sumNode = size(node,1);
% global stiffness matrix

[GK] = globalK(node,elem,k,ndim);

% right hand vector
ff = zeros(sumNode,1);

nodeL = find(node(:,1)<0.001); % 模型最左侧节点
nodeR = find(node(:,1)>0.999);    % 模型最右侧节点


uh = zeros(sumNode,1);
uh(nodeL) = 0;
uh(nodeR) = 1;
freeDof = setdiff(1:sumNode,[nodeL;nodeR]');
uh(freeDof) = GK(freeDof,freeDof)\(ff(freeDof)-GK(freeDof,[nodeL;nodeR])*uh([nodeL;nodeR]));
% showresult(node,elem,pde.uexact,uh);

% Plot mesh
subplot(1,2,1);
showmesh(node,elem); 
hold on;
plot(node(:,1),node(:,2),'k.', 'MarkerSize', 4);

% Plot numerical solution
subplot(1,2,2);
showsolution(node,elem,uh(1:size(node,1),1));

